# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ChatDocument(pydantic.BaseModel):
    """
    Relevant information that could be used by the model to generate a more accurate reply.
    The contents of each document are generally short (under 300 words), and are passed in the form of a
    dictionary of strings. Some suggested keys are "text", "author", "date". Both the key name and the value will be
    passed to the model.
    """

    id: typing.Optional[str] = pydantic.Field(description="Unique identifier for this document.")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
